#!/bin/bash
# test file to try to read status of the one relay board

#gets the response from the relay card and writes it to file testread
# the "&" at the end lets it run in the background - don't need cntl-c to get out of script
# ready to receive information from the relay card
echo "before cat line"
cat < /dev/ttyUSB0 > testread &
# $! returns the pid of the last process ran in the background - in this case the above line
bgPid=$!
echo "PID of the background cat process is:"
echo $bgPid

# sends request status to the relay card
echo -e "\xff\x01\x03" > /dev/ttyUSB0

#sleep is needed! Presumaably to get the response from the relay card
sleep 1
echo "before kill"
# kills the background process
kill $bgPid
echo "after kill"

echo "after background process has been killed"
# changes content of the file testread to hexidecimial and writes to file testreadh
# this did not work if done before the background process was killed - may have to do with file testread being open
echo "before line xxd testread > testreadh"
xxd testread > testreadh
echo "the next line is output of cat testreadh"
cat testreadh


# sets variable state to the state the relay is (00 = off; 01=on)
# the cut command extracts columns 15 and 16 from the file testreadh
state=$(cut -c15-16 ./testreadh)
echo $state

# checks if relay is off
if [ $state -eq 0 ]; then
   echo "The relay is off"
# put any commands here you want to run if the relay is off
   exit
fi

# checks if relay is on
if [ $state -eq 1 ]; then
   echo "The relay is on"
# put any commands here you want to run if the relay is on
   exit
fi

echo "Something is wrong - the state of the relay is neither 00 nor 01"
exit



